<?php

namespace App\Http\Controllers\master;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\CountryModel;
use App\Services\ReportService;
use Validator;

class ReportController extends Controller
{
  private function validateAccesToken($access_token)
  {
    return ['id' => 1, 'name' => 'ADMIN'];
  }
  public function report(REQUEST $request)
  {
    $status   = "0";
    $message  = "";
    $o_data   = [];
    $errors   = [];
    try {
      $user    = $this->validateAccesToken($request->access_token);
      $rows = $request->rows;
      $title = $request->title;
      $columns = $request->columns;
      $reportService = (new ReportService($rows, $columns, $title));
      $fileLink = $reportService->handle();

      if ($fileLink) {
        $status   = "1";
        $message = "Report generated successfully";
      } else {
        $message = "no data to show for your request";
      }
    } catch (\Exception $e) {
      $status = "0";
      $message = $e->getMessage();
      $errors = [
        'error' => $e->getMessage()
      ];
    }

    return response()->json(['status' => $status, 'error' => (object)$errors, 'message' => $message, 'oData' => ['link' => $fileLink]], 200);
  }
}
