<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class AccountCategory extends Model
{
    use HasFactory;

    protected $table='CONT_AcCategory';
    public $timestamps = false;

    protected $guarded = [];

    protected static function boot()
    {
        parent::boot();

        static::creating(function ($accountCategory) {
            // Get the current max ID
            $maxId = self::max('ACC_IdRecord');

            // Extract numeric part, increment, and pad with zeros
            $nextId = (int) substr($maxId, 2) + 1;
            $formattedNextId = 'AC' . str_pad($nextId, 4, '0', STR_PAD_LEFT);

            // Set the new ID for the current model instance
            $accountCategory->ACC_IdRecord = $formattedNextId;
        });
    }
}

